Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 247366 - Ability to show full diff off all modified files
Ability to show full diff off all modified files
Status: RESOLVED FIXED
Product: versioncontrol
Classification: Unclassified
Component: Git
8.0.1
All All
: P3 (vote)
: 8.1
Assigned To: Ondrej Vrabec
issues@versioncontrol
:
Depends on: 248002
Blocks:
  Show dependency treegraph
 
Reported: 2014-09-22 14:11 UTC by hifi
Modified: 2014-10-29 15:48 UTC (History)
1 user (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description hifi 2014-09-22 14:11:05 UTC
When coming from a command line background, I usually use 'git diff' to get a quick full overlook of what I'm going to commit.

In NetBeans when I do a git diff to HEAD for example, a diff tab is opened that has all invidual files listed and clicking one of them shows a single file diff. This is very slow compared to the command line commands and paging through the fill diff and then going back to the code to fix something up you forgot.

Another place where this would be extremely helpful is when I'm in the commit window. Having the option to display the full diff in one text field would allow quick skimming through the changes before you hit the commit button like described. Current way of double clicking each file into invidual diff tab feels really cumbersome and it's hard to grasp the big picture of your commit.

AFAIK this would only work with the text type diff which I prefer over the visual one.

I'm not sure if this should be for the diff component or for the invidual VCS component but please update the issue accordingly.
Comment 1 Ondrej Vrabec 2014-09-22 14:29:06 UTC
you can do Git -> Patches -> Export Uncommitted patch, but i guess we could squeeze the same output somewhere in commit/diff view
Comment 2 hifi 2014-09-22 14:45:51 UTC
I think one unintrusive way to offer this in possibly all views would be to change the default diff view to "full diff" if you have no files selected and the new default would be that instead of pre-selecting the first file of the diff file listing none would be. Also when selecting more than one file with Ctrl down it could show the diff for all of the selected files in the same single diff making it very consistent and predictable.

In the commit window a new button "Show diff" to open up the diff tab with above changes would be actually pretty neat as now double clicking opens up the same diff view as everywhere else but for single files only. This functionality could be fairly easy to integrate but it is very tied to the text diff.

Currently if you unselect all files in the diff view (wherever you are using it) it shows an empty box with "<No File Selected>".

This might be dependant on bug 247064 and the suggestion I gave there to be able the text diff as your global default in preferences.

Does this make sense and sound reasonable?
Comment 3 Ondrej Vrabec 2014-10-27 15:19:49 UTC
With this fix it is now possible. Both in Git -> Diff or the diff opened from the commit window, cancel the current selection in the file table (i.e. make no file selected) and click on the panel displaying: "Select a file or click to view the overall diff" -> after a click you'll get the textual diff for all files.

fix: http://hg.netbeans.org/core-main/rev/57109301ef43
Comment 4 hifi 2014-10-28 05:56:33 UTC
Thank you for implementing this. I'd give it a go, but the nightly builds have stopped at 19th October for some reason.
Comment 5 hifi 2014-10-28 06:14:08 UTC
Nevermind, the main-golden repo was the daily build source and it hasn't been merged since 18th.
Comment 6 Quality Engineering 2014-10-29 11:43:02 UTC
Integrated into 'main-silver', will be available in build *201410290913* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)

Changeset: http://hg.netbeans.org/main-silver/rev/57109301ef43
User: Ondrej Vrabec <ovrabec@netbeans.org>
Log: #247366 - Ability to show full diff off all modified files
Comment 7 hifi 2014-10-29 15:48:36 UTC
Thank you. I have now tested this and it works beautifully.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo